3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]'
11 git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
28 THIS_INDEX="$GIT_DIR/index"
29 NEXT_INDEX="$GIT_DIR/next-index$$"
32 cp -p "$THIS_INDEX" "$NEXT_INDEX"
36 # If TMP_INDEX is defined, that means we are doing
37 # "--only" partial commit, and that index file is used
38 # to build the tree for the commit. Otherwise, if
39 # NEXT_INDEX exists, that is the index file used to
40 # make the commit. Otherwise we are using as-is commit
41 # so the regular index file is what we use to compare.
42 if test '' != "$TMP_INDEX"
44 GIT_INDEX_FILE="$TMP_INDEX"
46 elif test -f "$NEXT_INDEX"
48 GIT_INDEX_FILE="$NEXT_INDEX"
52 case "$status_only" in
56 git-runstatus ${color} \
57 ${verbose:+--verbose} \
59 ${untracked_files:+--untracked}
63 test -z "$TMP_INDEX" || {
64 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
69 ################################################################
70 # Command line argument parsing and sanity checking
89 while case "$#" in 0) break;; esac
92 -F|--F|-f|--f|--fi|--fil|--file)
93 case "$#" in 1) usage ;; esac
102 log_given=t$log_given
103 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
106 --F=*|--f=*|--fi=*|--fil=*|--file=*)
108 log_given=t$log_given
109 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
116 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
117 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
120 --au|--aut|--auth|--autho|--author)
121 case "$#" in 1) usage ;; esac
126 -e|--e|--ed|--edi|--edit)
130 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
134 -o|--o|--on|--onl|--only)
138 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
139 case "$#" in 1) usage ;; esac
141 log_given=m$log_given
142 if test "$log_message" = ''
146 log_message="$log_message
154 log_given=m$log_given
155 if test "$log_message" = ''
157 log_message=`expr "z$1" : 'z-m\(.*\)'`
159 log_message="$log_message
161 `expr "z$1" : 'z-m\(.*\)'`"
166 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
167 log_given=m$log_given
168 if test "$log_message" = ''
170 log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
172 log_message="$log_message
174 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
179 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
184 --a|--am|--ame|--amen|--amend)
186 log_given=t$log_given
191 case "$#" in 1) usage ;; esac
193 log_given=t$log_given
198 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
199 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
200 --reedit-messag=*|--reedit-message=*)
201 log_given=t$log_given
202 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
206 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
207 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
209 case "$#" in 1) usage ;; esac
211 log_given=t$log_given
217 case "$#" in 1) usage ;; esac
219 log_given=t$log_given
224 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
225 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
227 log_given=t$log_given
228 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
232 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
233 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
234 case "$#" in 1) usage ;; esac
236 log_given=t$log_given
241 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
245 -q|--q|--qu|--qui|--quie|--quiet)
249 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
253 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
254 --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
255 --untracked-file|--untracked-files)
271 case "$edit_flag" in t) no_edit= ;; esac
273 ################################################################
274 # Sanity check options
276 case "$amend,$initial_commit" in
278 die "You do not have anything to amend." ;;
280 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
281 die "You are in the middle of a merge -- cannot amend."
287 die "Only one of -c/-C/-F/--amend can be used." ;;
289 die "Option -m cannot be combined with -c/-C/-F/--amend." ;;
292 case "$#,$also,$only,$amend" in
294 die "Only one of --include/--only can be used." ;;
296 die "No paths with --include/--only does not make sense." ;;
298 only_include_assumed="# Clever... amending the last one with dirty index." ;;
302 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
307 case "$all,$also,$#" in
309 die "Cannot use -a and -i at the same time." ;;
311 die "Paths with -a does not make sense." ;;
313 die "No paths with -i does not make sense." ;;
316 ################################################################
317 # Prepare index to have a tree to be committed
321 if test ! -f "$THIS_INDEX"
323 die 'nothing to commit (use "git add file1 file2" to include for commit)'
328 GIT_INDEX_FILE="$NEXT_INDEX" &&
329 export GIT_INDEX_FILE &&
330 git-diff-files --name-only -z |
331 git-update-index --remove -z --stdin
336 git-ls-files --error-unmatch -- "$@" >/dev/null || exit
338 git-diff-files --name-only -z -- "$@" |
341 GIT_INDEX_FILE="$NEXT_INDEX" &&
342 export GIT_INDEX_FILE &&
343 git-update-index --remove -z --stdin
351 if test -f "$GIT_DIR/MERGE_HEAD"
353 refuse_partial "Cannot do a partial commit during a merge."
355 TMP_INDEX="$GIT_DIR/tmp-index$$"
356 commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
358 # Build a temporary index and update the real index
360 if test -z "$initial_commit"
362 cp "$THIS_INDEX" "$TMP_INDEX"
363 GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
368 echo "$commit_only" |
369 GIT_INDEX_FILE="$TMP_INDEX" \
370 git-update-index --add --remove --stdin &&
373 echo "$commit_only" |
375 GIT_INDEX_FILE="$NEXT_INDEX"
376 export GIT_INDEX_FILE
377 git-update-index --remove --stdin
384 ################################################################
385 # If we do as-is commit, the index file will be THIS_INDEX,
386 # otherwise NEXT_INDEX after we make this commit. We leave
387 # the index as is if we abort.
389 if test -f "$NEXT_INDEX"
391 USE_INDEX="$NEXT_INDEX"
393 USE_INDEX="$THIS_INDEX"
396 case "$status_only" in
398 # This will silently fail in a read-only repository, which is
400 GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --unmerged --refresh
405 GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --refresh || exit
409 ################################################################
410 # Grab commit message, write out tree and make commit.
412 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
416 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
418 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
422 if test "$log_message" != ''
425 elif test "$logfile" != ""
427 if test "$logfile" = -
430 echo >&2 "(reading log message from standard input)"
435 elif test "$use_commit" != ""
437 encoding=$(git config i18n.commitencoding || echo UTF-8)
438 git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
439 sed -e '1,/^$/d' -e 's/^ //'
440 elif test -f "$GIT_DIR/MERGE_MSG"
442 cat "$GIT_DIR/MERGE_MSG"
443 elif test -f "$GIT_DIR/SQUASH_MSG"
445 cat "$GIT_DIR/SQUASH_MSG"
446 fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
450 need_blank_before_signoff=
451 tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
452 grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes
454 test -z "$need_blank_before_signoff" || echo
455 git-var GIT_COMMITTER_IDENT | sed -e '
459 } >>"$GIT_DIR"/COMMIT_EDITMSG
463 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
465 echo "# It looks like you may be committing a MERGE."
466 echo "# If this is not correct, please remove the file"
467 echo "# $GIT_DIR/MERGE_HEAD"
468 echo "# and try again"
470 fi >>"$GIT_DIR"/COMMIT_EDITMSG
473 if test '' != "$use_commit"
477 s/'\''/'\''\\'\'\''/g
479 s/^author \([^<]*\) <[^>]*> .*$/\1/
481 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
484 s/^author [^<]* <\([^>]*\)> .*$/\1/
486 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
489 s/^author [^<]* <[^>]*> \(.*\)$/\1/
491 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
496 encoding=$(git config i18n.commitencoding || echo UTF-8)
497 set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
498 LANG=C LC_ALL=C sed -ne "$pick_author_script"`
499 eval "$set_author_env"
500 export GIT_AUTHOR_NAME
501 export GIT_AUTHOR_EMAIL
502 export GIT_AUTHOR_DATE
504 if test '' != "$force_author"
506 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
507 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
508 test '' != "$GIT_AUTHOR_NAME" &&
509 test '' != "$GIT_AUTHOR_EMAIL" ||
510 die "malformed --author parameter"
511 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
515 if test -z "$initial_commit"
518 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
519 rloga='commit (merge)'
520 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
521 elif test -n "$amend"; then
522 rloga='commit (amend)'
523 PARENTS=$(git-cat-file commit HEAD |
524 sed -n -e '/^$/q' -e 's/^parent /-p /p')
526 current="$(git-rev-parse --verify HEAD)"
528 if [ -z "$(git-ls-files)" ]; then
529 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
533 rloga='commit (initial)'
536 set_reflog_action "$rloga"
538 if test -z "$no_edit"
542 echo "# Please enter the commit message for your changes."
543 echo "# (Comment lines starting with '#' will not be included)"
544 test -z "$only_include_assumed" || echo "$only_include_assumed"
546 } >>"$GIT_DIR"/COMMIT_EDITMSG
548 # we need to check if there is anything to commit
549 run_status >/dev/null
551 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
553 rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
560 case "${VISUAL:-$EDITOR},$TERM" in
562 echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
563 echo >&2 "Please supply the commit log message using either"
564 echo >&2 "-m or -F option. A boilerplate log message has"
565 echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
569 git-var GIT_AUTHOR_IDENT > /dev/null || die
570 git-var GIT_COMMITTER_IDENT > /dev/null || die
571 ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
577 if test -x "$GIT_DIR"/hooks/commit-msg
579 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
583 if test -z "$no_edit"
591 ' "$GIT_DIR"/COMMIT_EDITMSG
593 cat "$GIT_DIR"/COMMIT_EDITMSG
595 git-stripspace >"$GIT_DIR"/COMMIT_MSG
597 if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
602 if test -z "$TMP_INDEX"
604 tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
606 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
609 commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
610 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
611 git-update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
612 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
613 if test -f "$NEXT_INDEX"
615 mv "$NEXT_INDEX" "$THIS_INDEX"
620 echo >&2 "* no commit message? aborting commit."
624 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
625 if test -d "$GIT_DIR/rr-cache"
632 if test -x "$GIT_DIR"/hooks/post-commit
634 "$GIT_DIR"/hooks/post-commit
638 echo "Created${initial_commit:+ initial} commit $commit"
639 git-diff-tree --shortstat --summary --root --no-commit-id HEAD --